searchNodes=[{"doc":"Generate localized routes and route helper modules. This module when use d , provides a localize/1 macro that is designed to wrap the standard Phoenix route macros such as get/3 , put/3 and resources/3 and localises them for each locale defined in a Gettext backend module attached to a Cldr backend module. Translations for the parts of a given route path are translated at compile-time which are then combined into a localised route that is added to the standard Phoenix routing framework. As a result, users can enter URLs using localised terms which can enhance user engagement and content relevance. Similarly, a localised path and URL helpers are generated that wrap the standard Phoenix helpers to supporting generating localised path and URLs. Setting up A Cldr backend module that configures a Gettext asosciated backend is required. Path parts (the parts between &quot;/&quot;) are translated at compile time using Gettext . Therefore localization can only be applied to locales that are defined in a gettext backend module that is configured in a Cldr backend module. For example: defmodule MyApp.Cldr do use Cldr , locales : [ &quot;en&quot; , &quot;fr&quot; ] , default_locale : &quot;en&quot; . gettext : MyApp.Gettext providers : [ Cldr.Routes ] end Here the MyApp.Cldr backend module is used to instrospect the configured locales in order to drive the localization generation. Next, configure the router module to use the localize/1 macro by adding use MyApp.Cldr.Routes to the module and invoke the localize/1 macro to wrap the required routes. For example: defmodule MyApp.Router do use Phoenix.Router use MyApp.Cldr.Routes localize do get &quot;/pages/:page&quot; , PageController , :show resources &quot;/users&quot; , UsersController end end The following routes are generated (assuming that translations are updated in the Gettext configuration). For this example, the :fr translations are the same as the english text with _fr appended. % mix phx.routes MyApp.Router page_path GET /pages/:page PageController :show page_path GET /pages_fr/:page PageController :show users_path GET /users UsersController :index users_path GET /users/:id/edit UsersController :edit users_path GET /users/new UsersController :new users_path GET /users/:id UsersController :show users_path POST /users UsersController :create users_path PATCH /users/:id UsersController :update PUT /users/:id UsersController :update users_path DELETE /users/:id UsersController :delete users_path GET /users_fr UsersController :index users_path GET /users_fr/:id/edit UsersController :edit users_path GET /users_fr/new UsersController :new users_path GET /users_fr/:id UsersController :show users_path POST /users_fr UsersController :create users_path PATCH /users_fr/:id UsersController :update PUT /users_fr/:id UsersController :update users_path DELETE /users_fr/:id UsersController :delete Translations In order for routes to be localized, translations must be provided for each path segment. This translation is performed by Gettext.dgettext/3 with the domain &quot;routes&quot;. Therefore for each configured locale, a &quot;routes.pot&quot; file is required containing the path segment translations for that locale. Using the example Cldr backend that has &quot;en&quot; and &quot;fr&quot; Gettext locales then the directory structure would look like the following (if the default Gettext configuration is used): priv / gettext ├ ─ ─ default . pot ├ ─ ─ en │ └ ─ ─ LC_MESSAGES │ ├ ─ ─ default . po │ ├ ─ ─ errors . po │ └ ─ ─ routes . po ├ ─ ─ errors . pot └ ─ ─ fr └ ─ ─ LC_MESSAGES ├ ─ ─ default . po ├ ─ ─ errors . po └ ─ ─ routes . po Note that since the translations are performed with the functional form at compile time, the message ids are not autoamtically populated and must be manually added to the &quot;routes.pot&quot; file for each locale.","ref":"Cldr.Routes.html","title":"Cldr.Routes","type":"module"},{"doc":"Generates localised routes for each locale defined in a Cldr backend. This macro is intended to wrap a series of standard route definitiosn in a do block. For example: localize do get &quot;/pages/:page&quot; , PageController , :show resources &quot;/users&quot; , UsersController end","ref":"Cldr.Routes.html#localize/1","title":"Cldr.Routes.localize/1","type":"macro"},{"doc":"Generates localised routes for each locale provided. This macro is intended to wrap a series of standard route definitiosn in a do block. For example: localize [ :en , :fr ] do get &quot;/pages/:page&quot; , PageController , :show resources &quot;/users&quot; , UsersController end","ref":"Cldr.Routes.html#localize/2","title":"Cldr.Routes.localize/2","type":"macro"},{"doc":"Generate localized routes and route helper modules. This module when use d , provides a localize/1 macro that is designed to wrap the standard Phoenix route macros such as get/3 , put/3 and resources/3 and localises them for each locale defined in a Gettext backend module attached to a Cldr backend module. Translations for the parts of a given route path are translated at compile-time which are then combined into a localised route that is added to the standard Phoenix routing framework. As a result, users can enter URLs using localised terms which can enhance user engagement and content relevance. Similarly, a localised path and URL helpers are generated that wrap the standard Phoenix helpers to supporting generating localised paths and URLs.","ref":"readme.html","title":"Cldr Routes","type":"extras"},{"doc":"A Cldr backend module that configures an associated gettext backend is required. Path parts (the parts between &quot;/&quot;) are translated at compile time using Gettext . Therefore localization can only be applied to locales that are defined in a gettext backend module that attached to a Cldr backend module. For example: defmodule MyApp.Cldr do use Cldr , locales : [ &quot;en&quot; , &quot;fr&quot; ] , default_locale : &quot;en&quot; . gettext : MyApp.Gettext providers : [ Cldr.Routes ] end Here the MyApp.Cldr backend module is used to instrospect the configured locales in order to drive the localization generation. Next, configure the router module to use the localize/1 macro by adding use MyApp.Cldr.Routes to the module and invoke the localize/1 macro to wrap the required routes. For example: defmodule MyApp.Router do use Phoenix.Router use MyApp.Cldr.Routes localize do get &quot;/pages/:page&quot; , PageController , :show resources &quot;/users&quot; , UsersController end end The following routes are generated (assuming that translations are updated in the Gettext configuration). For this example, the :fr translations are the same as the :en text with _fr appended. % mix phx.routes MyApp.Router page_path GET /pages/:page PageController :show page_path GET /pages_fr/:page PageController :show users_path GET /users UsersController :index users_path GET /users/:id/edit UsersController :edit users_path GET /users/new UsersController :new users_path GET /users/:id UsersController :show users_path POST /users UsersController :create users_path PATCH /users/:id UsersController :update PUT /users/:id UsersController :update users_path DELETE /users/:id UsersController :delete users_path GET /users_fr UsersController :index users_path GET /users_fr/:id/edit UsersController :edit users_path GET /users_fr/new UsersController :new users_path GET /users_fr/:id UsersController :show users_path POST /users_fr UsersController :create users_path PATCH /users_fr/:id UsersController :update PUT /users_fr/:id UsersController :update users_path DELETE /users_fr/:id UsersController :delete","ref":"readme.html#setting-up","title":"Cldr Routes - Setting up","type":"extras"},{"doc":"In order for routes to be localized, translations must be provided for each path segment in each locale. This translation is performed by Gettext.dgettext/3 with the domain &quot;routes&quot;. Therefore for each configured locale, a &quot;routes.pot&quot; file is required containing the path segment translations for that locale. Using the example Cldr backend that has &quot;en&quot; and &quot;fr&quot; Gettext locales then the directory structure would look like the following (if the default Gettext configuration is used): priv / gettext ├ ─ ─ default . pot ├ ─ ─ en │ └ ─ ─ LC_MESSAGES │ ├ ─ ─ default . po │ ├ ─ ─ errors . po │ └ ─ ─ routes . po ├ ─ ─ errors . pot └ ─ ─ fr └ ─ ─ LC_MESSAGES ├ ─ ─ default . po ├ ─ ─ errors . po └ ─ ─ routes . po Note that since the translations are performed with Gettext.dgettext/3 at compile time, the message ids are not autoamtically populated and must be manually added to the &quot;routes.pot&quot; file for each locale. That is, the mix tasks mix gettext.extract and mix gettext.merge will not detect or extract the route segments.","ref":"readme.html#translations","title":"Cldr Routes - Translations","type":"extras"},{"doc":"In the same way that Phoenix generates a MyApp.Router.Helpers module, ex_cldr_routes also generates a MyApp.Router.LocalizedHelpers module that translates localized paths. Since this module is generated alongside the standard Helpers module, an application can decide to generate either canonical paths or localized paths. Here are some examples, assuming the same Cldr and Gettext configuration as the previous examples: iex&gt; MyApp.Router.LocalizedHelpers . page_path % Plug.Conn { } , :show , 1 &quot;/pages/1&quot; iex&gt; Gettext . put_locale MyAppWeb.Gettext , &quot;fr&quot; nil iex&gt; MyApp.Router.LocalizedHelpers . page_path % Plug.Conn { } , :show , 1 &quot;/pages_fr/1&quot;","ref":"readme.html#path-helpers","title":"Cldr Routes - Path Helpers","type":"extras"},{"doc":"For each localized path, the Cldr locale is added to the :assigns for the route under the :cldr_locale key. This allows the developer to recognise which locale was used to generate the localized route.","ref":"readme.html#assigns","title":"Cldr Routes - Assigns","type":"extras"},{"doc":"The package can be installed by adding ex_cldr_routes to your list of dependencies in mix.exs : def deps do [ { :ex_cldr_routes , &quot;~&gt; 0.1.0&quot; } ] end The docs canbe found at https://hexdocs.pm/ex_cldr_routes .","ref":"readme.html#installation","title":"Cldr Routes - Installation","type":"extras"},{"doc":"Copyright 2018-2020 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Cldr Routes version 0.1.0-rc.0 released on March 26th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Initial release","ref":"changelog.html#cldr-routes-v1-0-0-rc-0","title":"Changelog - Cldr Routes v1.0.0-rc.0","type":"extras"}]